﻿using System;
using System.Threading;

namespace LoopThreading
{
    public class GenericContextThread<ContextType>
    {
        readonly Thread thread;
        readonly Action<ContextType> method;

        ContextType cachedContext;

        public GenericContextThread(Action<ContextType> method)
        {
            this.method = method;
            thread = new Thread(DoWork);
        }

        public void Start(ContextType context)
        {
            cachedContext = context;
            thread.Start();
        }

        public void Join()
        {
            thread.Join();
        }

        void DoWork()
        {
            method(cachedContext);
        }
    }
}
