﻿using System;

namespace LoopThreading
{
    public static class SlowFunctions
    {
        const long BesselIterations = 100;

        static double Factorial(double n)
        {
            if (n == 0) return 1;
            return n * Factorial(n - 1);
        }

        public static double Bessel(double z)
        {
            double sum = 0;

            for (long k = 0; k < BesselIterations; k++)
            {
                double denominator = Math.Pow(Factorial(k), 2);
                double numerator = Math.Pow(0.25 * Math.Pow(z, 2), k);
                double quotient = numerator / denominator;
                sum += quotient;
            }

            return sum;
        }
    }
}
